Summary: Apache Module mod_remoteip
Name: mod_remoteip
Version: 0.1.20100929
Release: 1%{?dist}
License: ASL 2.0
Group: System Environment/Daemons
URL: http://httpd.apache.org/docs/trunk/mod/mod_remoteip.html
Source0: http://people.apache.org/~wrowe/httpd-2.2-ports/mod_remoteip.c
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: httpd >= 2.2, httpd < 2.3
Requires: httpd-mmn = %([ -a %{_includedir}/httpd/.mmn ] && cat %{_includedir}/httpd/.mmn || echo missing)
BuildRequires: httpd-devel >= 2.2, httpd-devel < 2.3

%description
This module is used to treat the remote host which initiated the request as the
originating remote host as identified by httpd for the purposes of authorization
and logging, even where that remote host is behind a load balancer, front end
server, or proxy server.

The module replaces the apparent remote (client) IP/hostname for the request
with the IP address reported in the request header configured with the
RemoteIPHeader directive.

Once replaced as instructed, this apparent IP address is then used for 
mod_authz_host features <Require host> and <Require ip>, is reported by
mod_status, and is recorded by mod_log_config a and h directives. It also 
determines the machine probed for an inetd identity by mod_ident based on the
IdentityCheck configuration.

%prep
install %{SOURCE0} .

%build
/usr/sbin/apxs -Wc,"%{optflags}" -c mod_remoteip.c

%install
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d/
install -Dp .libs/mod_remoteip.so %{buildroot}%{_libdir}/httpd/modules/mod_remoteip.so

cat << EOF > %{buildroot}%{_sysconfdir}/httpd/conf.d/mod_remoteip.conf
LoadModule remoteip_module modules/mod_remoteip.so

<IfModule mod_remoteip.c>
   # Proxies:
   RemoteIPHeader X-Forwarded-For 
   # Load Balancers
   #RemoteIPHeader X-Client-IP

   # Trusted (Proxy) Example
   #RemoteIPHeader X-Forwarded-For
   #RemoteIPTrustedProxy 10.0.2.16/28
   #RemoteIPTrustedProxy proxy.example.com 
   
   # Trusted (Load Balancer) Example
   #RemoteIPHeader X-Client-IP
   #RemoteIPTrustedProxy 10.0.2.16/28
   #RemoteIPTrustedProxy proxy.example.com 
</IfModule>

EOF

%clean
rm -rf %{buildroot}

%files
%defattr (-,root,root)
%{_libdir}/httpd/modules/mod_remoteip.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_remoteip.conf

%changelog
* Tue Nov 23 2010 Jonathan Steffan <jsteffan@fedoraproject.org> - 0.1.20100929-1
- Inital Package

